Subject: Re: bug#7004: 23.2; In fullscreen mode, the echo area takes too much vertical space

From: Jan Djärv <[email-masked]>
Date: Fri, 17 Sep 2010 07:25:26 +0200

martin rudalics skrev 2010-09-16 18.17:

> - The height of any such bar is indicated in lines. In this case we
> subtract their heights as multiples of canonical line heights.

This is the case for the native menu bar and the native tool bar.

>
> - The height of such a bar cannot be calculated in canonical line
> heights. In this case we must have subtracted their height from
> the total frame height and rounded the remainder in terms of
> canonical line heights _before_ calling change_frame_size so we
> have case (1) again.

This is the case for toolkit menu/tool bar.

>
> In any case the value for the frame root window/minibuffer window
> heights is specified by subtracting
>
> #define FRAME_TOP_MARGIN(F) \
> (FRAME_MENU_BAR_LINES (F) + FRAME_TOOL_BAR_LINES (F))
>
> from the line numbers value passed to change_frame_size. At the time we
> do that, the lines of the bar must either not have been reflected in the
> argument for change_frame_size or be specified as numbers of lines.
>

These values are zero for toolkit menu/tool bar.  They are not the same as the 
frame parameter with similar name.  This is quite obvious when reading the source.

Notice that change_frame_size takes lines/columns as arguments, not pixels, so 
windows can only be sized in those increments.

	Jan D.